package de.accso.flexinale.infrastructure.security;

import de.accso.flexinale.domain.model.Besucher;
import de.accso.flexinale.infrastructure.security.mapper.BenutzerEntity2BesucherMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

@Service
public class BenutzerDetailsService implements UserDetailsService {

    @Autowired
    private BenutzerJpaRepository benutzerJpaRepository;

    @Override
    public UserDetails loadUserByUsername(final String login) throws UsernameNotFoundException {
        Optional<BenutzerEntity> benutzer = benutzerJpaRepository.findByLogin(login);
        if (benutzer.isEmpty()) { // login is unique
            throw new UsernameNotFoundException("No Benutzer %s found".formatted(login));
        }
        return new UserPrincipal(benutzer.get());
    }

    public Besucher getLoggedInBesucher() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        String userLogin = authentication.getName();
        Optional<BenutzerEntity> benutzer = benutzerJpaRepository.findByLogin(userLogin);

        if (benutzer.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.EXPECTATION_FAILED,
                    "None or more than one Besucher with login " + userLogin);
        }
        else {
            return BenutzerEntity2BesucherMapper.map(benutzer.get());
        }
    }
}
